/*******************************************************************************
 * Licensed Materials - Property of IBM
 * Copyright IBM Corp. 2011, 2012.  All Rights Reserved.
 * 
 * US Government Users Restricted Rights - Use, duplication or disclosure
 * restricted by GSA ADP Schedule Contract with IBM Corp.
 *******************************************************************************/

(function(){
   
dojo.provide("com.ibm.team.vvc.shared.web.ui.changesets.CreateChangesetForm");

dojo.require('dojo.i18n');
dojo.require("dijit.form.Button");
dojo.require("dijit.form.DateTextBox");
dojo.require("dijit.form.SimpleTextarea");
dojo.require("dijit.form.TextBox");
dojo.require("dijit.form.CheckBox");
dojo.require("dijit.form.Form");

dojo.require("com.ibm.team.vvc.shared.web.ui.DialogForm");
dojo.require("com.ibm.team.vvc.shared.web.ui.context.ContextUtils");

dojo.require("jazz.util.ResizeNotifier");

dojo.requireLocalization("com.ibm.team.vvc.shared.web.ui.changesets", "ChangesetsMessages");

var ContextUtils = 	com.ibm.team.vvc.shared.web.ui.context.ContextUtils;

dojo.declare("com.ibm.team.vvc.shared.web.ui.changesets.CreateChangesetForm", com.ibm.team.vvc.shared.web.ui.DialogForm, {
	
	templateString: dojo.cache('com.ibm.team.vvc.shared.web', 'ui/changesets/templates/CreateChangesetForm.html'),
	_configuration: null,
	widgetsInTemplate: true,
	
	constructor: function(args) {
		this.messages = dojo.i18n.getLocalization("com.ibm.team.vvc.shared.web.ui.changesets", "ChangesetsMessages");	
		if (args == null && args.configuration == null)
			throw "Must pass in the configuration to the CreateChangesetForm constructor";
		else
			this._configuration = args.configuration;
	},
	
	postCreate: function() {
		this.inherited(arguments);
	},
	
	getDialogArguments: function(){
		return {
			contentNode: this.containerNode,
			primaryTitle: this.messages.createChangesetDialogTitle,
			destroyContents: true,
			width: "600px"
		};
	},
		
	_onCreate: function(){
		var title= this._changesetTitleTextBox.get('value');
		var url = '/changesets?configuration=' + this._configuration;
		if (title) {
			 url += '&name=' + encodeURIComponent(title);
		}
		jazz.client.xhrPost({
			handleAs: 'text',
			sync: true,
			url: net.jazz.ajax.contextRoot() + '/vvcshared/proxy',
			headers: {
				"vvc_servicePath" : url,
			},

			load: dojo.hitch(this, function(response, ioArgs) {
				if (ioArgs) {
					var xhr = ioArgs.xhr;
					if (xhr) {
						dojo.publish("vvc.changeset_created", [{
							type: 'changeset',
							id:xhr.getResponseHeader("Location"),
							uri:xhr.getResponseHeader("Location"),
							configurationUri: xhr.getResponseHeader("configurationUri"),
							title:title,
							state:'IN_PROGRESS'}]);
					}
				}
			}),
			
			error: dojo.hitch(this, function(e) {
				console.log(e);
				if (this.displayErrorMessage)
					this.displayErrorMessage("Error: "+e.message);
				else
					alert('error '+e.message);
			})
		});
		this.hide();		
	},
	
	show: function() {
		this.inherited(arguments);
		
		// set initial focus
		this._changesetTitleTextBox.focus();
	},
	
	_onCancel: function(){
		this.hide();
	}
	
});

})();